
------------------------------- Sample user tables ------------------------------- 
DROP TABLE customer;

CREATE TABLE customer 
(
	pkey		VARCHAR(10) NOT NULL	PRIMARY KEY,
	fname		VARCHAR(20),
	lname		VARCHAR(20),
	ccode		VARCHAR(10)
);

CREATE TABLE address 
(
	addrid		VARCHAR(10) NOT NULL	PRIMARY KEY,
	custid		VARCHAR(10),
	city			VARCHAR(20),
	zipcode	VARCHAR(10),
	FOREIGN KEY(custid) REFERENCES customer(pkey)
);


CREATE TABLE custinfo 
(
	ccode		VARCHAR(10) NOT NULL	PRIMARY KEY,
	cdata		VARCHAR(10)
);



------------------------------------- Event table -------------------------------------

DROP TABLE wbia_jdbc_eventstore

CREATE TABLE WBIA_JDBC_EVENTSTORE (
	event_id		DECIMAL(20) IDENTITY(1,1)	PRIMARY KEY,
	xid			VARCHAR(200),			
	object_key		VARCHAR(80)		NOT NULL,
	object_name		VARCHAR(40)		NOT NULL,
	object_function		VARCHAR(40)		NOT NULL,
	event_priority		DECIMAL(5)		NOT NULL,
	event_time		DATETIME		DEFAULT GETDATE()	NOT NULL,
	event_status		DECIMAL(5)		NOT NULL,
	event_comment		VARCHAR(100)
);



------------------------------------- Triggers for customer table -------------------------------------

DROP TRIGGER EVENT_CREATE;
DROP TRIGGER EVENT_UPDATE;
DROP TRIGGER EVENT_DELETE;


CREATE TRIGGER event_create
ON CUSTOMER
FOR INSERT 
AS
DECLARE @newKey VARCHAR(10) 
SELECT @newKey = (SELECT PKEY FROM Inserted)
BEGIN
INSERT INTO wbia_jdbc_eventstore (object_key, object_name, object_function, event_priority, event_status) 
VALUES (@newKey, 'InDb2adminCustomerBG', 'Create', 1, 0)
END


CREATE TRIGGER event_update
ON CUSTOMER
FOR UPDATE 
AS
DECLARE @updatedKey VARCHAR(10) 
SELECT @updatedKey = (SELECT PKEY FROM Inserted)
BEGIN
INSERT INTO wbia_jdbc_eventstore (object_key, object_name, object_function, event_priority, event_status) 
VALUES (@updatedKey, 'InDb2adminCustomerBG', 'Update', 1, 0)
END


CREATE TRIGGER event_delete
ON CUSTOMER
FOR DELETE 
AS
DECLARE @deletedKey VARCHAR(10) 
SELECT @deletedKey = (SELECT PKEY FROM Deleted)
BEGIN
INSERT INTO wbia_jdbc_eventstore (object_key, object_name, object_function, event_priority, event_status) 
VALUES (@deletedKey, 'InDb2adminCustomerBG', 'Delete', 1, 0)
END
